/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* This software is public domain. Permission is granted to     *
* use, copy and modify this software to anyone.                *
****************************************************************
* Please don't contact me for information, bugs, comments, job *
* offers. If you like this software, please send a postcard to *
* the following address:                                       *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA                                                      *
****************************************************************
* The author is not liable for damages resulting from  the use *
* of this software or its derivates.                           *
\**************************************************************/

import java.applet.Applet;
import java.awt.Color;

public class VasScrollStatus extends Applet implements Runnable {
  String msg;
  int refresh=60;
  int curr=0;
  int msgLen;
  Thread showMsg;

  public String getAppletInfo() {
    return (new String("VasScrollStatus v1.0 March 31st, 1998, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }

  public void init() {
    //refreshtime
    try {
      refresh=Integer.parseInt(getParameter("refresh"));
      if(refresh<10) refresh=60;
    }
    catch(Exception e) {refresh=60;}

    //we'll put a background color, 'cause default applet size is 5x5
    try{
      //what will be the background of the applet (better to be the same as the HTML page's)
      //for example #000000 for black or #FFFFFF for white
      //we take the parameters from the web page
      String color=getParameter("color");
      if(color==null) color=new String("#B4B88C");
      setBackground(new Color(Integer.parseInt(color.substring(1, 3), 16), Integer.parseInt(color.substring(3, 5), 16), Integer.parseInt(color.substring(5, 7), 16)));
    }
    catch(Exception ee) {;}

    //the message to show
    String byDefault=new String("   (C) VasScrollStatus");
    msg=getParameter("msg");
    msg=new String(msg+byDefault);
    msgLen=msg.length();
    StringBuffer tempo=new StringBuffer(msg+msg);
    for(int i=0; i<msgLen; i++) tempo.setCharAt(i, ' ');
    msg=tempo.toString();
    msgLen=msg.length();
    showMsg=new Thread(this);
    showMsg.start();
  }

  public void start() {
    if(showMsg==null) {
      showMsg=new Thread(this);
      showMsg.start();
    }
  }

  public void stop() {
    if(showMsg!=null) {
      showMsg.stop();
      showMsg=null;
    }
  }

  public void run() {
    while(true) {
      try {
        showStatus(msg.substring (curr>0 ? curr : -curr));
        if(++curr==msgLen-1) curr=-curr;
        Thread.sleep((long)refresh);
      }
      catch(InterruptedException e) {stop();}
    }
  }
}//end class VasShowStatus
